## maas 1.8.3+bzr4053

=== Makefile ===
python := python2.7

# Network activity can be suppressed by setting offline=true (or any
# non-empty string) at the command-line.
ifeq ($(offline),)
buildout := bin/buildout
virtualenv := virtualenv
else
buildout := bin/buildout buildout:offline=true
virtualenv := virtualenv --never-download
endif

# If offline has been selected, attempt to further block HTTP/HTTPS
# activity by setting bogus proxies in the environment.
ifneq ($(offline),)
export http_proxy := broken
export https_proxy := broken
endif

# Python enum modules.
py_enums := $(wildcard src/*/enum.py)
# JavaScript enum module (not modules).
js_enums := src/maasserver/static/js/enums.js

# MAAS SASS stylesheets. The first input file (maas-styles.css) imports
# the others, so is treated specially in the target definitions.
scss_inputs := \
    src/maasserver/static/scss/maas-styles.scss \
    $(wildcard src/maasserver/static/scss/*/*.scss) \
    $(wildcard src/maasserver/static/scss/*/*/*.scss)
scss_output := src/maasserver/static/css/maas-styles.css

# Prefix commands with this when they need access to the database.
# Remember to add a dependency on bin/database from the targets in
# which those commands appear.
dbrun := bin/database --preserve run --

# For things that care, postgresfixture for example, we always want to
# use the "maas" databases.
export PGDATABASE := maas

# For anything we start, we want to hint as to its root directory.
export MAAS_ROOT := $(CURDIR)/run

build: \
    bin/buildout \
    bin/database \
    bin/maas \
    bin/maas-probe-dhcp \
    bin/maas-provision \
    bin/maas-region-admin \
    bin/twistd.cluster \
    bin/twistd.region \
    bin/test.cli \
    bin/test.cluster \
    bin/test.config \
    bin/test.e2e \
    bin/test.js \
    bin/test.region \
    bin/test.testing \
    bin/py bin/ipy \
    $(js_enums)

all: build doc

release_codename := $(shell lsb_release -c -s)

# Install all packages required for MAAS development & operation on
# the system. This may prompt for a password.
install-dependencies:
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    --no-install-recommends install $(shell sort -u \
	        $(addprefix required-packages/,base build dev doc $(release_codename)))
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    purge $(shell sort -u required-packages/forbidden)

.gitignore: .bzrignore
	sed 's:^[.]/:/:' $^ > $@
	echo '/src/**/*.pyc' >> $@
	echo '/etc/**/*.pyc' >> $@

bin/python:
	$(virtualenv) --python=$(python) --system-site-packages $(CURDIR)
	bin/pip install hypothesis==0.7.2  # buildout can't install this.

configure-buildout:
	utilities/configure-buildout

bin/buildout: bin/python bootstrap/zc.buildout-1.5.2.tar.gz
	@utilities/configure-buildout --quiet
	bin/python -m pip --quiet install --ignore-installed \
	    --no-dependencies bootstrap/zc.buildout-1.5.2.tar.gz
	$(RM) README.txt  # zc.buildout installs an annoying README.txt.
	@touch --no-create $@  # Ensure it's newer than its dependencies.

bin/database: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install database
	@touch --no-create $@

bin/maas-region-admin bin/twistd.region: \
    bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install region
	@touch --no-create $@

bin/test.region: \
    bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install region-test
	@touch --no-create $@

bin/maas: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install cli
	@touch --no-create $@

bin/test.cli: bin/buildout buildout.cfg versions.cfg setup.py bin/maas
	$(buildout) install cli-test
	@touch --no-create $@

bin/test.js: bin/karma bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install js-test
	@touch --no-create $@

bin/test.e2e: bin/protractor bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install e2e-test
	@touch --no-create $@

bin/test.testing: \
	bin/buildout bin/sass buildout.cfg versions.cfg setup.py
	$(buildout) install testing-test
	@touch --no-create $@

bin/maas-probe-dhcp bin/maas-provision bin/twistd.cluster: \
    bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install cluster
	@touch --no-create $@

bin/test.cluster: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install cluster-test
	@touch --no-create $@

bin/test.config: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install config-test
	@touch --no-create $@

bin/flake8: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install flake8
	@touch --no-create $@

bin/rst-lint: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install rst-lint
	@touch --no-create $@

bin/sphinx bin/sphinx-build: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install sphinx
	@touch --no-create $@

bin/py bin/ipy: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install repl
	@touch --no-create bin/py bin/ipy

define karma-deps
  karma@0.12.32
  karma-chrome-launcher@0.1.12
  karma-firefox-launcher@0.1.6
  karma-jasmine@0.3.5
  karma-opera-launcher@0.1.0
  karma-phantomjs-launcher@0.1.4
  karma-failed-reporter@0.0.3
endef

bin/karma: deps = $(strip $(karma-deps))
bin/karma: prefix = include/nodejs
bin/karma:
	@mkdir -p $(@D) $(prefix)
	npm install --cache-min 600 --prefix $(prefix) $(deps)
	@ln -srf $(prefix)/node_modules/karma/bin/karma $@

bin/protractor: prefix = include/nodejs
bin/protractor:
	@mkdir -p $(@D) $(prefix)
	npm install --cache-min 600 --prefix $(prefix) protractor@2.0.0
	@ln -srf $(prefix)/node_modules/protractor/bin/protractor $@

bin/sass: prefix = include/nodejs
bin/sass:
	@mkdir -p $(@D) $(prefix)
	npm install --cache-min 600 --prefix $(prefix) node-sass@3.1.0
	@ln -srf $(prefix)/node_modules/node-sass/bin/node-sass $@

test: test-scripts-all = $(wildcard bin/test.*)
# Don't run bin/test.e2e for now; it breaks.
test: test-scripts = $(filter-out bin/test.e2e,$(test-scripts-all))
test: build
	@$(RM) coverage.data
	@echo $(test-scripts) | xargs --verbose -n1 env

test+coverage: export NOSE_WITH_COVERAGE = 1
test+coverage: test

coverage-report: coverage/index.html
	sensible-browser $< > /dev/null 2>&1 &

coverage.xml: coverage.data
	python-coverage xml --include 'src/*' -o $@

coverage/index.html: coverage.data
	@$(RM) -r $(@D)
	python-coverage html --include 'src/*' -d $(@D)

coverage.data:
	@$(error Use `$(MAKE) test` to generate coverage data, or invoke a \
            test script using the `--with-coverage` flag)

lint: lint-py lint-js lint-doc lint-rst

pocketlint = $(call available,pocketlint,python-pocket-lint)

# XXX jtv 2014-02-25: Clean up this lint, then make it part of "make lint".
lint-css: sources = src/maasserver/static/css
lint-css:
	@find $(sources) -type f \
	    -print0 | xargs -r0 $(pocketlint) --max-length=120

# Python lint checks are time-intensive, so we run them in parallel.  It may
# make things matters worse if the files need to be read from disk, though, so
# this may need more tuning.
# The -n50 -P4 setting roughly doubled speed on a high-end system with SSD and
# all the files in cache.
lint-py: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
lint-py: bin/flake8
	@find $(sources) -name '*.py' ! -path '*/migrations/*' -print0 \
	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123 --config=/dev/null
	@utilities/check-maaslog-exception

lint-doc:
	@utilities/doc-lint

# lint-rst 0.11.1 shouldn't be used on our documentation because it
# doesn't understand Sphinx's extensions, and doesn't grok linking
# between documents, hence complaints about broken links. However,
# Sphinx itself warns about lint when building the docs.
lint-rst: sources = README HACKING.txt schema/README.rst
lint-rst: bin/rst-lint
	@find $(sources) -type f \
	    -printf 'Linting %p...\n' \
	    -exec bin/rst-lint --encoding=utf8 {} \;

# JavaScript lint is checked in parallel for speed.  The -n20 -P4 seetting
# worked well on a multicore SSD machine with the files cached, roughly
# doubling the speed, but it may need tuning for slower systems or cold caches.
lint-js: sources = src/maasserver/static/js
lint-js:
	@find $(sources) -type f ! -path '*/angular/3rdparty/*' -print0 '(' -name '*.html' -o -name '*.js' ')' \
		| xargs -r0 -n20 -P4 $(pocketlint)

# Apply automated formatting to all Python files.
format: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
format:
	@find $(sources) -name '*.py' -print0 | xargs -r0 utilities/format-imports

check: clean test

docs/api.rst: bin/maas-region-admin src/maasserver/api/doc_handler.py syncdb
	bin/maas-region-admin generate_api_doc > $@

sampledata: bin/maas-region-admin bin/database syncdb
	$(dbrun) bin/maas-region-admin loaddata src/maasserver/fixtures/dev_fixture.yaml

doc: bin/sphinx docs/api.rst
	bin/sphinx

doc-with-versions: bin/sphinx docs/api.rst
	cd docs/_build; make SPHINXOPTS="-A add_version_switcher=true" html

man: $(patsubst docs/man/%.rst,man/%,$(wildcard docs/man/*.rst))

man/%: docs/man/%.rst | bin/sphinx-build
	bin/sphinx-build -b man docs man $^

enums: $(js_enums)

$(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
	 bin/py -m src/maasserver/utils/jsenums $(py_enums) > $@

styles: bin/sass clean-styles $(scss_output)

$(scss_output): $(scss_inputs)
	bin/sass --include-path=src/maasserver/static/scss --output-style compressed $< -o $(dir $@)

clean-styles:
	$(RM) $(scss_output)

clean: stop
	$(MAKE) -C acceptance $@
	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
	find . -type f -name '*~' -print0 | xargs -r0 $(RM)
	find . -type f -name dropin.cache -print0 | xargs -r0 $(RM)
	$(RM) -r media/demo/* media/development
	$(RM) $(js_enums)
	$(RM) *.log
	$(RM) docs/api.rst
	$(RM) -r docs/_autosummary docs/_build
	$(RM) -r man/.doctrees
	$(RM) coverage.data coverage.xml
	$(RM) -r coverage
	$(RM) -r bin include lib local
	$(RM) -r eggs develop-eggs
	$(RM) -r build dist logs/* parts
	$(RM) tags TAGS .installed.cfg
	$(RM) -r *.egg *.egg-info src/*.egg-info
	$(RM) -r run/* run-e2e/* services/*/supervise

clean+db: clean
	$(RM) -r db

distclean: clean
	$(warning 'distclean' is deprecated; use 'clean')

harness: bin/maas-region-admin bin/database
	$(dbrun) bin/maas-region-admin shell --settings=maas.demo

dbharness: bin/database
	bin/database --preserve shell

syncdb: bin/maas-region-admin bin/database
	$(dbrun) bin/maas-region-admin syncdb --noinput
	$(dbrun) bin/maas-region-admin migrate maasserver --noinput
	$(dbrun) bin/maas-region-admin migrate metadataserver --noinput

# (Re)write the baseline schema.
schema/baseline.sql: bin/database
	$(dbrun) pg_dump -h $(PWD)/db/ -d maas --no-owner --no-privileges -f $@

# Synchronise the database, and update the baseline schema.
baseline-schema: syncdb schema/baseline.sql

define phony_targets
  build
  check
  clean
  clean-styles
  clean+db
  configure-buildout
  coverage-report
  dbharness
  distclean
  doc
  enums
  format
  harness
  install-dependencies
  lint
  lint-css
  lint-doc
  lint-js
  lint-py
  lint-rst
  man
  package
  package-clean
  package-dev
  package-dev-clean
  sampledata
  source_package
  styles
  syncdb
  test
  test+coverage
endef

#
# Development services.
#

service_names_region := database dns regiond regiond2 reloader
service_names_cluster := clusterd reloader
service_names_all := $(service_names_region) $(service_names_cluster)

# The following template is intended to be used with `call`, and it
# accepts a single argument: a target name. The target name must
# correspond to a service action (see "Pseudo-magic targets" below).
# A region- and cluster-specific variant of the target will be
# created, in addition to the target itself. These can be used to
# apply the service action to the region services, the cluster
# services, or all services, at the same time.
define service_template
$(1)-region: $(patsubst %,services/%/@$(1),$(service_names_region))
$(1)-cluster: $(patsubst %,services/%/@$(1),$(service_names_cluster))
