=== debian/changelog ===
maas (1.8.3+bzr4053-0ubuntu1) wily; urgency=medium

  * New upstream release, 1.8.3 bzr 4053:
    - Declare dependency on metadataserver migration 0015 by maasserver
      migration 0121 to allow upgrades from 1.5.4 to 1.8 to work. (LP: #1495064)
    - Fix the issue where the included ':', apache2 wont forward the
      connection (LP: #1484696)
    - Fixes autocomplete styling for tagging (LP: #1489160)
    - Add HPDSA hardware drivers to the drivers config (LP: #1491898)
    - Always invoke the init system using the C.UTF-8 locale. (LP: #1491822)
    - Use cluster_name instead of name for the cluster, otherwise the UI
      will show the DNS zone name instead of the actual cluster name.
    - Fix twisted related Internal Server Error when IPv6 addresses present
      in wily. (LP: #1504971)
  * debian/control: Restart maas-clusterd in the event it failed to start
    due to missing /var/lib/maas/secret (LP: #1471946) 

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 08 Oct 2015 21:53:04 -0700

maas (1.8.2+bzr4041-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.2 bzr 4041:
    - Regenerate the connection URL on websocket client reconnect, to fix
      CSRF after upgrade to 1.8.1. (LP: #1484696)
    - Validate the osystem and distro_series when using the deploy action,
      which fixes win2012r2 deployment issues. (LP: #1445942)
    - Fix failure in MAAS startup messages by not generating dhcpd config
      files when they are not in use. (LP: #1481940)
    - Fix enlistment to always use the correct kernel parameters. (LP: #1459865)
  * debian/control: Add missing dep on python-curtin.
  * debian/maas-cluster-controller.postinst: Drop mangling of apache2.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 17 Aug 2015 11:31:20 +0100

maas (1.8.1+bzr4036-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.1 bzr4036:
    - Add --username to maas-region-admin apikey command
      docs. (LP: ##1481118)
    - Add ListBootImagesV2 RPC command; fallback to using ListBootImages
      when the ListBootImagesV2 is not handled on the cluster.
    - Fix setting the default_distro_series over the API (LP: #1470591)
    - Fix upgrade issue where it would remove custom DNS config,
      potentially breaking DNS (LP: #1413388)
    - Commissioning x86_64 node never completes, sitting at grub
      prompt, pserv py tbs (LP: #1317705)
    - Power monitor service hits amp.TooLong errors with > ~600
      nodes to a cluster (LP: #1389007)
    - Websocket server accessed over port 5240 (LP: #1436279)
    - If hostname not set, sudo warning make maas throw 500 (LP: #1469305)    
    - Can't set a list of forwarders (BIND config) (LP: #1470585)
    - UCS chassis enlist Failed to probe and enlist UCS nodes: list
      index out of range (LP: #1469846)
    - Add cisco snic to 3rd party driver (LP: #1470276)
    - console= parameters need to be added before -- on kernel
      cmdline (LP: #1402042)
    - [UI] Machine details styling (LP: #1465722)
    - [UI] Actions design styles (LP: #1465737)
    - [UI] Replace close "X" with correct versions (LP: #1465740)
    - [UI] Table design styles (LP: #1465742)
    - [UI] Make table heading hover consistant with nodes/devices
      tabs (LP: #1470389)
    - [UI] adding between node name and save button
      inconsistent (LP: #1470395)
    - [UI] "Set zone" label oddly placed on node listing
      page (LP: #1459710)

  [ Raphaël Badin ]
  * Enable proxy_wstunnel module.
  * Drop dependency on python-iscpy: the code has been integrated into
    MAAS. (LP: #1413388).

  [ Andres Rodriguez ]
  * Refactor maas-dns upgrade code so it doesn't break local DNS config
    and it gets migrated (LP: #1413388)
    - debian/maas-region-controller.postinst: Ensure DNS config migration
      is always run.
  * debian/control: Make maas-dns a Dependy of maas-region-controller.

  [ Scott Moser ]
  * maas-proxy: sync white space changes with trunk packaging branch
  * maas-proxy: sync apt specific squid config with squid-deb-proxy
    (LP: #1474417)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 06 Jul 2015 23:52:59 -0400

maas (1.8.0+bzr4001-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 09 Jun 2015 20:57:42 -0400

maas (1.8.0~rc3+bzr4000-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 RC3 bzr4000.

  [ Raphaël Badin ]
  * Remove unused dependencies: python-amqp and python-txamqp.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 04 Jun 2015 16:32:02 -0400

maas (1.8.0~rc2+bzr3989-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 RC2 bzr3983.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 02 Jun 2015 09:27:54 -0400

maas (1.8.0~rc1+bzr3972-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 RC1 bzr3972.
  * debian/copyright: Add copyright headers for ng-tags-input.js.
  * debian/control: Bump Standards-Version

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 27 May 2015 20:16:40 -0400

maas (1.8.0~beta8+bzr3951-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 beta 8 bzr3951.

  [ Raphaël Badin ]
  * debian/extras/99-maas-sudoers: Allow maas to check the status of
    maas-dhcpd and maas-dhcp6 and start these services (LP: #1457708).

  [ Andres Rodriguez ]
  * debian/rules: Ensure maas-regiond-worker is not started in packaging.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 21 May 2015 19:18:22 -0400

maas (1.8.0~beta7+bzr3926-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.8.0 beta 7 bzr3926.

  [ Andres Rodriguez ]
  * debian/{maas-cluster-controller,maas-common,
    maas-region-controller-min}.postinst: Cleaned up to correctly create
    log dir permissions (LP: #1457191)

  [ Gavin Panella ]
  * Create maas-regiond workers for systemd.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 20 May 2015 17:03:13 -0400

maas (1.8.0~beta6+bzr3891-0ubuntu1) trusty; urgency=medium


