## maas 1.9.5+bzr4599

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,9 @@
 python := python2.7
+
+# pkg_resources makes some incredible noise about version numbers. They
+# are not indications of bugs in MAAS so we silence them everywhere.
+export PYTHONWARNINGS = \
+  ignore:You have iterated over the result:RuntimeWarning:pkg_resources:
 
 # Network activity can be suppressed by setting offline=true (or any
 # non-empty string) at the command-line.
@@ -63,7 +68,7 @@
 
 all: build doc
 
-release_codename := $(shell lsb_release -c -s)
+release_codename = $(shell lsb_release -c -s)
 
 # Install all packages required for MAAS development & operation on
 # the system. This may prompt for a password.
@@ -81,7 +86,6 @@
 
 bin/python:
 	$(virtualenv) --python=$(python) --system-site-packages $(CURDIR)
-	bin/pip install hypothesis==0.7.2  # buildout can't install this.
 
 configure-buildout:
 	utilities/configure-buildout
@@ -228,7 +232,8 @@
 lint-py: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
 lint-py: bin/flake8
 	@find $(sources) -name '*.py' ! -path '*/migrations/*' -print0 \
-	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123 --config=/dev/null
+	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123,E402,E731 \
+	    --config=/dev/null
 	@utilities/check-maaslog-exception
 
 lint-doc:
@@ -244,7 +249,7 @@
 	    -printf 'Linting %p...\n' \
 	    -exec bin/rst-lint --encoding=utf8 {} \;
 
-# JavaScript lint is checked in parallel for speed.  The -n20 -P4 seetting
+# JavaScript lint is checked in parallel for speed.  The -n20 -P4 setting
 # worked well on a multicore SSD machine with the files cached, roughly
 # doubling the speed, but it may need tuning for slower systems or cold caches.
 lint-js: sources = src/maasserver/static/js
@@ -257,6 +262,14 @@
 format:
 	@find $(sources) -name '*.py' -print0 | xargs -r0 utilities/format-imports
 
+# Update copyright dates from version history. Try to avoid updating
+# 3rd-party code by checking for "Canonical" or "MAAS" on the same line
+# as the copyright header.
+copyright:
+	@bzr ls --versioned --recursive --kind=file --null | \
+	    xargs -r0 egrep -iI 'copyright.*(canonical|maas)' -lZ | \
+	    xargs -r0 bzr update-copyright --quiet --force-range
+
 check: clean test
 
 docs/api.rst: bin/maas-region-admin src/maasserver/api/doc_handler.py syncdb
@@ -268,8 +281,13 @@
 doc: bin/sphinx docs/api.rst
 	bin/sphinx
 
+docs/_build/html/index.html: doc
+
+doc-browse: docs/_build/html/index.html
+	sensible-browser $< > /dev/null 2>&1 &
+
 doc-with-versions: bin/sphinx docs/api.rst
-	cd docs/_build; make SPHINXOPTS="-A add_version_switcher=true" html
+	$(MAKE) -C docs/_build SPHINXOPTS="-A add_version_switcher=true" html
 
 man: $(patsubst docs/man/%.rst,man/%,$(wildcard docs/man/*.rst))
 
@@ -279,7 +297,7 @@
 enums: $(js_enums)
 
 $(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
-	 bin/py -m src/maasserver/utils/jsenums $(py_enums) > $@
+	 bin/py -m maasserver/utils/jsenums $(py_enums) > $@
 
 styles: bin/sass clean-styles $(scss_output)
 
@@ -289,7 +307,7 @@
 clean-styles:
 	$(RM) $(scss_output)
 
-clean: stop
+clean: stop clean-run
 	$(MAKE) -C acceptance $@
 	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
 	find . -type f -name '*~' -print0 | xargs -r0 $(RM)
@@ -302,15 +320,31 @@
 	$(RM) -r man/.doctrees
 	$(RM) coverage.data coverage.xml
 	$(RM) -r coverage
+	$(RM) -r .hypothesis
 	$(RM) -r bin include lib local
 	$(RM) -r eggs develop-eggs
 	$(RM) -r build dist logs/* parts
 	$(RM) tags TAGS .installed.cfg
 	$(RM) -r *.egg *.egg-info src/*.egg-info
-	$(RM) -r run/* run-e2e/* services/*/supervise
+	$(RM) -r services/*/supervise
+
+# Be selective about what to remove from run and run-e2e.
+define clean-run-template
+find $(1) -depth ! -type d \
+    ! -path $(1)/etc/maas/templates \
+    ! -path $(1)/etc/maas/drivers.yaml \
+    -print0 | xargs -r0 $(RM)
+find $(1) -depth -type d \
+    -print0 | xargs -r0 rmdir --ignore-fail-on-non-empty
+endef
+
+clean-run:
+	$(call clean-run-template,run)
+	$(call clean-run-template,run-e2e)
 
 clean+db: clean
 	$(RM) -r db
+	$(RM) .db.lock
 
 distclean: clean
 	$(warning 'distclean' is deprecated; use 'clean')
@@ -328,7 +362,7 @@
 
 # (Re)write the baseline schema.
 schema/baseline.sql: bin/database
-	$(dbrun) pg_dump -h $(PWD)/db/ -d maas --no-owner --no-privileges -f $@
+	$(dbrun) pg_dump -h $(CURDIR)/db -d maas --no-owner --no-privileges -f $@
 
 # Synchronise the database, and update the baseline schema.
 baseline-schema: syncdb schema/baseline.sql
@@ -337,51 +371,9 @@
   build
   check
   clean
+  clean+db
+  clean-run
   clean-styles
-  clean+db
   configure-buildout
+  copyright
   coverage-report
-  dbharness
-  distclean
-  doc
-  enums
-  format
-  harness
-  install-dependencies
-  lint
-  lint-css
-  lint-doc
-  lint-js
-  lint-py
-  lint-rst
-  man
-  package
-  package-clean
-  package-dev
-  package-dev-clean
-  sampledata
-  source_package
-  styles
-  syncdb
-  test
-  test+coverage
-endef
-
-#
-# Development services.
-#
-
-service_names_region := database dns regiond regiond2 reloader
-service_names_cluster := clusterd reloader
-service_names_all := $(service_names_region) $(service_names_cluster)
-
-# The following template is intended to be used with `call`, and it
-# accepts a single argument: a target name. The target name must
-# correspond to a service action (see "Pseudo-magic targets" below).
-# A region- and cluster-specific variant of the target will be
-# created, in addition to the target itself. These can be used to
-# apply the service action to the region services, the cluster
-# services, or all services, at the same time.
-define service_template
-$(1)-region: $(patsubst %,services/%/@$(1),$(service_names_region))
-$(1)-cluster: $(patsubst %,services/%/@$(1),$(service_names_cluster))
