=== debian/changelog ===
maas (1.9.5+bzr4599-0ubuntu1~14.04.3) trusty-proposed; urgency=medium

  * Stable Release Update.
    - debian/patches/harcode-upstart-lp1732703.patch: Running snapd or
      livepatch in Trusty installs systemd. Due to a systemd regressions,
      this causes  MAAS to incorrectly detect the init system. As such,
      hardcode the init system to upstart (as systemd is not supported
      in Ubuntu) (LP: #1732703).

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 13 Dec 2017 18:09:11 -0500

maas (1.9.5+bzr4599-0ubuntu1~14.04.2) trusty-proposed; urgency=medium

  * Stable Release Update.
    - debian/patches/fix-shim-name-lp1713795.patch: Grub package in Trusty
      has changed the name of the shim and has caused MAAS to being unable
      to import new images. (LP: #1713795)
    - debian/control: Bump depends on grub-common to ensure latest is
      always installed.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 31 Aug 2017 15:22:08 -0400

maas (1.9.5+bzr4599-0ubuntu1~14.04.1) trusty-proposed; urgency=medium

  * Stable Release Update. New MAAS upstream bugfix release 1.9.5 (LP: #1669591):
    - MAAS 1.9.5 is a new upstream bugfix release that fixes several bugs
      present on MAAS 1.9.4. This is solely a bugfix release. To see what
      issues this release fixes, please refer to the CHANGELOG
  * debian/control: Recommends bind9 (>= 1:9.9.5.dfsg-3ubuntu0.12~).

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 02 Mar 2017 16:58:13 -0500

maas (1.9.4+bzr4592-0ubuntu1~14.04.1) trusty-proposed; urgency=medium

  * New Upstream Release, 1.9 (LP: #1509147):
    - Support for Advanced Networking and Node Network Configuration:
      + Ability to declare Fabrics, Spaces, Subnets, VLANs and FANs.
      + Ability to assign subnets, fabrics and IP's to node interfaces.
      + Ability to create VLAN interfaces for nodes.
      + Ability to create Bond interfaces for nodes.
      + Ability to create interface names.
    - Support for Advanced Storage Configuration.
      + Ability to configure LVM.
      + Ability to configure BCache.
      + Ability to configure Software RAID Levels 0, 1, 5, 6, 10.
      + Ability to perform advanced partitioning.
    - Support for Curtin & Cloud-init status reporting.
    - Minimal config files for maas-regiond and maas-clusterd.
    - Better support for Hardware Enablement Kernels (HWE).
    - Support for Commissioning Actions.
    - Warn users about missing power tools.
    - Switch away from shell scripts to Python Power Drivers.
    - CentOS images can now be imported.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 12 Jul 2016 21:34:23 -0400

maas (1.7.6+bzr3376-0ubuntu3~14.04.1) trusty-proposed; urgency=medium

  * debian/patches/lp1573046.patch: No longer use distro-info --lts to
    detect the commissioning release, as it returns 'xenial' for LTS.
    MAAS 1.7 only supports trusty. (LP: #1573046)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 09 May 2016 16:29:28 -0400

maas (1.7.6+bzr3376-0ubuntu2~14.04.1) trusty; urgency=medium

  * debian/control: Make maas-dns a Dependy of maas-region-controller.
  * debian/maas-region-controller.postinst: Ensure DNS config migration is
    always run. (LP: #1413388)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 10 Jul 2015 13:47:40 -0400
