=== debian/control ===
--- 
+++ 
@@ -92,11 +92,10 @@
 Architecture: all
 Depends: python-bson,
          python-crochet,
-         python-curtin,
+         python-curtin (>= 0.1.0~bzr351),
          python-distro-info,
          python-formencode,
          python-jsonschema,
-         python-lockfile,
          python-lxml,
          python-maas-client (= ${binary:Version}),
          python-netifaces,
@@ -148,12 +147,11 @@
          bind9utils,
          distro-info,
          freeipmi-tools,
-         grub-common,
+         grub-common (>=  2.02~beta2-9ubuntu1.14),
          maas-cli (=${binary:Version}),
          maas-common (=${binary:Version}),
          maas-dhcp (=${binary:Version}),
          python-httplib2,
-         python-lockfile,
          python-maas-provisioningserver (=${binary:Version}),
          python-netaddr,
          python-oauth,
@@ -183,8 +181,7 @@
 Depends: python-apt,
          python-convoy,
          python-crochet,
-         python-curtin,
-         python-lockfile,
+         python-curtin (>> 0.1.0~bzr275),
          python-lxml,
          python-maas-client (= ${binary:Version}),
          python-netaddr,
@@ -212,6 +209,7 @@
 Depends: bind9,
  maas-region-controller-min (= ${binary:Version}),
  ${misc:Depends}
+Recommends: bind9 (>= 1:9.9.5.dfsg-3ubuntu0.12~)
 Conflicts: dnsmasq
 Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
 Replaces: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
