=== debian/rules ===
--- 
+++ 
@@ -74,4 +74,4 @@
               | sed -rne 's,^Version: ([^-]+).*,\1,p')
 get-orig-source:
 	bzr export -r $(REV) --root=maas-$(VER).orig \
-             maas_$(VER).orig.tar.gz lp:maas/1.8
+             maas_$(VER).orig.tar.gz lp:maas/1.9
